.\" Copyright (c) 1980, 1991 Regents of the University of California.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)fork.2	6.5 (Berkeley) 3/10/91
.\"	$NetBSD: i386_get_ldt.2,v 1.12 2003/04/16 13:34:34 wiz Exp $
.\"
.Dd September 20, 1993
.Dt I386_GET_LDT 2 i386
.Os
.Sh NAME
.Nm i386_get_ldt ,
.Nm i386_set_ldt
.Nd manage i386 per-process Local Descriptor Table entries
.Sh LIBRARY
.Lb libi386
.Sh SYNOPSIS
.In sys/types.h
.In machine/segments.h
.In machine/sysarch.h
.Ft int
.Fn i386_get_ldt "int start_sel" "union descriptor *descs" "int num_sels"
.Ft int
.Fn i386_set_ldt "int start_sel" "union descriptor *descs" "int num_sels"
.Sh DESCRIPTION
.Fn i386_get_ldt
will return the list of i386 descriptors that the process has in its
LDT.
.Fn i386_set_ldt
will set a list of i386 descriptors for the current process in its
LDT.
Both routines accept a starting selector number
.Fa start_sel
, an array of memory that
will contain the descriptors to be set or returned
.Fa descs
, and the number of entries to set or return
.Fa num_sels .
.Pp
The argument
.Fa descs
can be either segment_descriptor or gate_descriptor and are defined in
.Fd \*[Lt]i386/segments.h\*[Gt] .
These structures are defined by the architecture
as disjoint bit-fields, so care must be taken in constructing them.
.Sh RETURN VALUES
Upon successful completion,
.Fn i386_get_ldt
returns the number of descriptors currently in the LDT.
.Fn i386_set_ldt
returns the first selector set.
Otherwise, a value of \-1 is returned and the global
variable
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn i386_get_ldt
and
.Fn i386_set_ldt
will fail if:
.Bl -tag -width [EINVAL]
.It Bq Er EINVAL
An inappropriate parameter was used for
.Fa start_sel
or
.Fa num_sels .
.It Bq Er EACCES
The caller attempted to use a descriptor that would
circumvent protection or cause a failure.
.El
.Sh REFERENCES
i386 Microprocessor Programmer's Reference Manual, Intel
.Sh WARNING
You can really hose your process using this.
